using System;
using Benday.Npr.Common.DomainModel;
using System.Collections.Generic;
using Benday.Npr.Common.Repositories;
using Benday.Npr.Common;

namespace Benday.Npr.Business
{
    public class StoryDomainService : IStoryDomainService
    {
        public StoryDomainService(IStoryRepository repository)
        {
            if (repository == null)
                throw new ArgumentNullException("repository", "repository is null.");

            m_RepositoryInstance = repository;
        }

        private IStoryRepository m_RepositoryInstance;
        private IStoryRepository RepositoryInstance
        {
            get { return m_RepositoryInstance; }
        }

        public void GetStories(ReturnResult<IStoryList> action, string id)
        {
            RepositoryInstance.GetStories(action, id);
        }

        public void ResolveMp3UrlFromM3u(ReturnResult<string> action, string m3uUri)
        {
            RepositoryInstance.ResolveMp3UrlFromM3u(action, m3uUri);
        }
    }
}
