﻿using System;
using Benday.Npr.Common.Repositories;
using Benday.Npr.Common;
using Benday.Npr.Common.DomainModel;
using System.Net;
using System.IO;

namespace Benday.Npr.DataAccess
{
    public class FeedRepository : IFeedRepository
    {
        public FeedRepository(IObjectFactory factory)
        {
            if (factory == null)
                throw new ArgumentNullException("factory", "factory is null.");

            m_ObjectFactoryInstance = factory;
        }

        private IObjectFactory m_ObjectFactoryInstance;
        private IObjectFactory ObjectFactoryInstance
        {
            get { return m_ObjectFactoryInstance; }
        }

        public void GetAllPrograms(ReturnResult<IFeed> action)
        {
            if (action == null)
                throw new ArgumentNullException("action", "action is null.");

            string xml = DataAccessResources.NprAllPrograms;

            IFeedXmlAdapter adapter = ObjectFactoryInstance.Create<IFeedXmlAdapter>();

            IFeed returnValue = ObjectFactoryInstance.Create<IFeed>();

            adapter.Adapt(xml, returnValue);

            action.Notify(returnValue);
        }

        /*
        public void GetAllPrograms(ReturnResult<IFeed> action)
        {
            if (action == null)
                throw new ArgumentNullException("action", "action is null.");

            string url = "http://api.npr.org/list?id=3004";

            HttpWebRequest request = WebRequest.Create(url) as HttpWebRequest;

            request.BeginGetResponse(ProcessResult, new WebRequestReturnResult<IFeed>(request, action));
        }

        private void ProcessResult(IAsyncResult asyncResult)
        {
            WebRequestReturnResult<IFeed> action = asyncResult.AsyncState as WebRequestReturnResult<IFeed>;
            
            if (action == null)
            {
                throw new InvalidOperationException("User state was the wrong type.");
            }

            var response = action.Request.EndGetResponse(asyncResult);

            using (var stream = new StreamReader(response.GetResponseStream()))
            {
                string xml = stream.ReadToEnd();

                IFeedXmlAdapter adapter = ObjectFactoryInstance.Create<IFeedXmlAdapter>();

                IFeed returnValue = ObjectFactoryInstance.Create<IFeed>();

                adapter.Adapt(xml, returnValue);

                System.Windows.Deployment.Current.Dispatcher.BeginInvoke(() => action.ReturnResult.Notify(returnValue));
            }
        }
         * */
    }
}
