using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.Npr.Common.Repositories;
using Benday.Npr.Common.DomainModel;
using System.Xml.Linq;
using System.Linq;

namespace Benday.Npr.Silverlight.UnitTests.DataAccess
{
    public class UnitTestUtility
    {
        public UnitTestUtility()
        {

        }

        public static void AssertStringDoesNotContainUndisplayableHtmlFormatting(string checkThisString)
        {
            Assert.IsFalse(StringContainsUndisplayableHtmlFormatting(checkThisString), 
                "Should not contain any undisplayable html formatting.  ('{0}')", 
                checkThisString);
        }

        public static void AssertStringDoesNotContainUndisplayableHtmlFormatting(string checkThisString, string message)
        {
            Assert.IsFalse(StringContainsUndisplayableHtmlFormatting(checkThisString),
                "{1} should not contain any undisplayable html formatting.  ('{0}')",
                checkThisString, message);
        }

        public static bool StringContainsUndisplayableHtmlFormatting(string checkThisString)
        {
            Assert.IsNotNull(checkThisString, "String was null.");

            if (checkThisString.Contains("&lt;em&gt;") == true || 
                checkThisString.Contains("&lt;/em&gt;") == true || 
                checkThisString.Contains("<em>") == true || 
                checkThisString.Contains("</em>") == true || 
                checkThisString.Contains("<strong>") == true || 
                checkThisString.Contains("</strong>") == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
