using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.Npr.Common.Repositories;
using Benday.Npr.Common.DomainModel;
using System.Xml.Linq;
using Benday.Npr.DataAccess;
using Microsoft.Silverlight.Testing;
using Benday.Npr.Common;

namespace Benday.Npr.Silverlight.UnitTests.DataAccess
{
    [TestClass]
    [Tag("xml")]
    public class XmlUtilityFixture : UnitTestBase
    {
        [TestMethod]
        public void XmlUtility_GetChildElementValueByElementNameAndAttributeId()
        {
            string xml = TestDataUtility.XmlWithSimilarChildElementsWithDifferentAttributes();

            // <link type="html">http://www.npr.org/2010/11/10/131216486/in-israel-when-is-a-jew-not-jewish-enough?ft=3&amp;f=2</link>

            string expected = "http://www.npr.org/2010/11/10/131216486/in-israel-when-is-a-jew-not-jewish-enough?ft=3&f=2";

            var root = XmlUtility.StringToXDocument(xml);

            var actual = XmlUtility.GetChildElementValue(root.Root, "link", "type", "html", String.Empty);

            Assert.AreEqual<string>(expected, actual, "Value was wrong.");
        }
    }
}
