﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.Npr.Common;

namespace Benday.Npr.Silverlight.UnitTests
{
    [TestClass]
    public class ObjectIdentityFixture : UnitTestBase
    {
        [TestMethod]
        public void ObjectIdentity_CreateInstance()
        {
            var instance = ObjectFactoryInstance.Create<IObjectIdentity>();

            Assert.IsNotNull(instance, "Instance was null.");
        }

        [TestMethod]
        public void ObjectIdentity_ValueInitializedToUnsavedValue()
        {
            var instance = ObjectFactoryInstance.Create<IObjectIdentity>();

            Assert.AreEqual<string>(instance.UnsavedValue, instance.Value, "Value should be unsaved value after ctor.");
        }

        [TestMethod]
        public void ObjectIdentity_IsSaved()
        {
            var instance = ObjectFactoryInstance.Create<IObjectIdentity>();

            instance.Value = instance.UnsavedValue;
            Assert.IsFalse(instance.IsSaved, "Should not be saved.");

            instance.Value = "asdf";
            Assert.IsTrue(instance.IsSaved, "Should be saved.");

        }
    }
}