using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Microsoft.Phone.Controls;

namespace Benday.Npr.Phone
{
    public static class ApplicationUtility
    {
        public static void NavigateToMainPage()
        {
            PhoneApplicationFrame root = Application.Current.RootVisual as PhoneApplicationFrame;

            if (root != null && DoesCurrentRootVisualSourceContain("MainPage.xaml") == false)
            {
                root.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
            }
        }

        public static bool DoesCurrentRootVisualSourceContain(string searchFor)
        {
            if (String.IsNullOrEmpty(searchFor) == true)
            {
                return false;
            }
            else
            {
                PhoneApplicationFrame root = Application.Current.RootVisual as PhoneApplicationFrame;

                if (root != null && root.CurrentSource != null)
                {
                    var currentSourceAsString = root.CurrentSource.ToString();

                    if (currentSourceAsString.Contains(searchFor) == true)
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
        }
    }
}
