﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Navigation;
using Benday.Npr.Presentation;
using Microsoft.Phone.Tasks;
using Microsoft.Xna.Framework.Media;
using Microsoft.Phone.BackgroundAudio;

namespace Benday.Npr.Phone
{
    public partial class StoryDetailsPage : PhoneApplicationPage
    {
        public StoryDetailsPage()
        {
            InitializeComponent();            
        }

        private ApplicationBarBindingHelper m_ApplicationBarHelper;
        public ApplicationBarBindingHelper ApplicationBarHelper
        {
            get { return m_ApplicationBarHelper; }
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            
        }

        public void CheckDataContextAndEventSubscriptions()
        {
            if (ViewModelLocator.Instance.CurrentStory != null)
            {
                var viewModel = ViewModelLocator.Instance.CurrentStory;

                this.DataContext = viewModel;

                viewModel.OnReadyToPlayMp3 += new EventHandler(viewModel_OnReadyToPlayMp3);
            }
        }
        
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            CheckDataContextAndEventSubscriptions();
        }

        private void CheckApplicationBarHelper()
        {
            if (m_ApplicationBarHelper == null)
            {
                m_ApplicationBarHelper = new ApplicationBarBindingHelper(this.ApplicationBar, ViewModelLocator.Instance.AllPrograms.MediaPlayback);
            }
        }

        private void PlayTrack()
        {
            try
            {
                var storyViewModel = ViewModelLocator.Instance.CurrentStory;
                var programViewModel = ViewModelLocator.Instance.CurrentProgram;
                Uri uri = new Uri(storyViewModel.ResolvedUrlToMp3, UriKind.RelativeOrAbsolute);

                AudioTrack track = new AudioTrack(uri, 
                                       storyViewModel.Title, 
                                       programViewModel.Title, 
                                       storyViewModel.PublishDate.ToShortDateString(), 
                                       null);

                BackgroundAudioPlayer.Instance.Track = track;
                BackgroundAudioPlayer.Instance.Play();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        /*
        private void PlayTrack()
        {
            try
            {
                Uri uri = new Uri(ViewModelLocator.Instance.CurrentStory.ResolvedUrlToMp3, UriKind.RelativeOrAbsolute);

                Song song = Song.FromUri(Guid.NewGuid().ToString(), uri);

                Microsoft.Xna.Framework.Media.MediaPlayer.Play(song);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        */
        private void CheckPlaybackStateAndOptionallyPlayTrack()
        {
            if (MediaPlayer.GameHasControl == false && MediaPlayer.State == MediaState.Playing)
            {
                var result = MessageBox.Show("Would you like to stop the current music playback?", 
                                 "Stop current track?", 
                                 MessageBoxButton.OKCancel);
                
                if (result == MessageBoxResult.OK)
                {
                    PlayTrack();
                }
            }
            else
            {
                PlayTrack();
            }
        }

        void viewModel_OnReadyToPlayMp3(object sender, EventArgs e)
        {
            CheckPlaybackStateAndOptionallyPlayTrack();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                ViewModelLocator.Instance.CurrentStory.PlayMp3();      
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            } 
        }

        
    }
}