﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Benday.Npr.Presentation;
using Benday.Npr.Presentation.Interfaces;

namespace Benday.Npr.Phone
{
    public partial class StoryListPage : PhoneApplicationPage
    {
        // Constructor
        public StoryListPage()
        {
            InitializeComponent();
        }

        private ApplicationBarBindingHelper m_ApplicationBarHelper;
        public ApplicationBarBindingHelper ApplicationBarHelper
        {
            get { return m_ApplicationBarHelper; }
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            m_ViewModel = ViewModelLocator.Instance.StoryListInstance;

            this.DataContext = m_ViewModel;
        }

        // When page is navigated to set data context to selected item in list
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (ViewModelLocator.IsInDesignModeStatic == false && ViewModelLocator.Instance.CurrentProgram != null)
            {
                m_ViewModel = ViewModelLocator.Instance.StoryListInstance;

                this.DataContext = m_ViewModel;

                if (ViewModelLocator.Instance.CurrentProgram != null &&
                    ViewModelLocator.Instance.CurrentProgram.Id != m_ViewModel.Id)
                {
                    m_ViewModel.Load(ViewModelLocator.Instance.CurrentProgram.Id);
                }

                m_ViewModel.OnSelectionChanged += new EventHandler(viewModel_OnSelectionChanged);

                // CheckApplicationBarHelper();
            }
        }

        private void CheckApplicationBarHelper()
        {
            if (m_ApplicationBarHelper == null)
            {
                m_ApplicationBarHelper = new ApplicationBarBindingHelper(this.ApplicationBar, ViewModelLocator.Instance.AllPrograms.MediaPlayback);
            }
        }

        private Benday.Npr.Presentation.Interfaces.IStoryListViewModel m_ViewModel;

        private void NavigateToStory()
        {
            if (m_ViewModel != null && m_ViewModel.SelectedItem != null)
            {
                NavigationService.Navigate(new Uri("/StoryDetailsPage.xaml", UriKind.Relative));
            }
        }

        void viewModel_OnSelectionChanged(object sender, EventArgs e)
        {
            NavigateToStory();
        }

        private void StackPanel_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            
        }

        private void StackPanel_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            NavigateToStory();
        }        
    }
}