using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Phone.Shell;

namespace Benday.Npr.Phone
{
    public abstract class ViewModelSerializerBase
    {
        public const string SERIALIZATION_KEY_STORY = "Story";
        public const string SERIALIZATION_KEY_PROGRAM = "Program";
        public const string SERIALIZATION_KEY_STORY_LIST = "StoryList";
        public const string SERIALIZATION_KEY_RESUME_ACTION = "ResumeAction";
        public const string SERIALIZATION_KEY_RESUME_ACTION_STORY = "STORY";
        public const string SERIALIZATION_KEY_RESUME_ACTION_PROGRAM = "PROGRAM";
        public const string SERIALIZATION_KEY_RESUME_ACTION_HOURLY_NEWS = "HOURLY NEWS";        

        public ViewModelSerializerBase()
        {

        }

        private static void RemoveStateValue(string key)
        {
            IDictionary<string, object> stateCollection = PhoneApplicationService.Current.State;

            if (stateCollection.ContainsKey(key) == true)
            {
                stateCollection.Remove(key);
            }
        }

        protected static string GetStateValue(string key)
        {
            IDictionary<string, object> stateCollection = PhoneApplicationService.Current.State;

            return stateCollection[key] as string;
        }

        protected static void SetStateValue(string key, string value)
        {
            RemoveStateValue(key);

            IDictionary<string, object> stateCollection = PhoneApplicationService.Current.State;

            stateCollection.Add(key, value);
        }

        protected static bool HasStateValue(string key)
        {
            IDictionary<string, object> stateCollection = PhoneApplicationService.Current.State;

            return stateCollection.ContainsKey(key);
        }

        public static void ClearState()
        {
            RemoveStateValue(SERIALIZATION_KEY_RESUME_ACTION);
            RemoveStateValue(SERIALIZATION_KEY_PROGRAM);
            RemoveStateValue(SERIALIZATION_KEY_STORY_LIST);
            RemoveStateValue(SERIALIZATION_KEY_STORY);
        }

        public static void SetResumeActionToProgram()
        {
            SetStateValue(SERIALIZATION_KEY_RESUME_ACTION, SERIALIZATION_KEY_RESUME_ACTION_PROGRAM);
        }

        public static void SetResumeActionToHourlyNews()
        {
            SetStateValue(SERIALIZATION_KEY_RESUME_ACTION, SERIALIZATION_KEY_RESUME_ACTION_HOURLY_NEWS);
        }
        
        public static void SetResumeActionToStory()
        {
            SetStateValue(SERIALIZATION_KEY_RESUME_ACTION, SERIALIZATION_KEY_RESUME_ACTION_STORY);            
        }
    }
}
