using System;
using GalaSoft.MvvmLight;
using System.Windows.Input;
using Benday.Npr.Presentation.Interfaces;

namespace Benday.Npr.Presentation
{
    public abstract class EditorViewModel : IdentityViewModel, IEditorViewModel
    {
        public EditorViewModel()
        {

        }

        public abstract void Save();
        public abstract void Cancel();

        private ICommand m_cancelCommand;
        public ICommand CancelCommand
        {
            get
            {
                if (m_cancelCommand == null)
                {
                    m_cancelCommand = new GalaSoft.MvvmLight.Command.RelayCommand(() => this.Cancel());
                }

                return m_cancelCommand;
            }
            set
            {
                m_cancelCommand = value;
            }
        }

        private ICommand m_saveCommand;
        public ICommand SaveCommand
        {
            get
            {
                if (m_saveCommand == null)
                {
                    m_saveCommand = new GalaSoft.MvvmLight.Command.RelayCommand(() => this.Save());
                }

                return m_saveCommand;
            }
            set
            {
                m_saveCommand = value;
            }
        }


    }
}
