using System;
using GalaSoft.MvvmLight;
using Benday.Npr.Common;

namespace Benday.Npr.Presentation
{
    public abstract class IdentityViewModel : NetworkAvailabilityViewModel
    {
        public IdentityViewModel()
        {
            Id = new ObjectIdentity();
        }

        private const string IdPropertyName = "Id";

        private IObjectIdentity m_Id;
        public IObjectIdentity Id
        {
            get
            {
                return m_Id;
            }
            set
            {
                m_Id = value;
                RaisePropertyChanged(IdPropertyName);
            }
        }        
    }
}
