using System;
using System.Windows.Input;
using System.Collections.ObjectModel;
using Benday.Npr.Common.DomainModel;

namespace Benday.Npr.Presentation.Interfaces
{
    public interface IStoryViewModel : IViewModelBase
    {
        void Load(IStory instance);

        string Id { get; set; }
        string UrlToHtml { get; set; }
        string UrlToApi { get; set; }
        string UrlShort { get; set; }
        string Title { get; set; }
        string Teaser { get; set; }
        string TeaserMini { get; set; }
        string Slug { get; set; }
        DateTime StoryDate { get; set; }
        DateTime PublishDate { get; set; }
        string ShowName { get; set; }
        DateTime ShowDate { get; set; }
        string OrganizationName { get; set; }
        string OrganizationAbbreviation { get; set; }
        string OrganizationUrl { get; set; }
        int Duration { get; set; }
        bool HasUrlToMp3 { get; set; }
        string UrlToMp3 { get; set; }
        bool HasUrlToWindowsMedia { get; set; }
        string UrlToWindowsMedia { get; set; }
        ObservableCollection<IParagraphViewModel> Paragraphs { get; set; }
        string Author { get; set; }

        void PlayMp3();
        bool HasResolvedUrlToMp3 { get; set; }
        string ResolvedUrlToMp3 { get; set; }

        event EventHandler OnReadyToPlayMp3;
    }
}
