using System;
using Benday.Npr.Phone.Common.Models;
using System.Collections.Generic;

namespace Benday.Npr.Phone.Common.Repositories
{

    public interface IStoryRepository
    {
        event EventHandler<StoryListRefreshedEventArgs> StoryListRefreshed;

        IStoryList GetStories(string programId);
        void RefreshStories(string programId);
        IStory GetStory(
            string programId, string storyId);
        void SaveCurrentStoryId(string storyId);
        string GetCurrentStoryId();

        void ResolveMp3UrlFromM3u(ReturnResult<string> action, string m3uUri);
    }
}
