using System;
using Benday.Npr.Phone.Common;
using System.Collections.Generic;
using System.Xml.Linq;

namespace Benday.Npr.Phone.DataAccess
{
    public abstract class AdapterBase
    {
        public AdapterBase(IObjectFactory factory)
        {
            if (factory == null)
                throw new ArgumentNullException("factory", "factory is null.");

            m_ObjectFactoryInstance = factory;
        }

        private IObjectFactory m_ObjectFactoryInstance;
        public IObjectFactory ObjectFactoryInstance
        {
            get { return m_ObjectFactoryInstance; }
        }

        public XDocument StringToXDocument(string fromValue)
        {
            return XmlUtility.StringToXDocument(fromValue);
        }
    }
}
