using System;
using Benday.Npr.Phone.Common;
using System.Net;

namespace Benday.Npr.Phone.DataAccess
{
    public class WebRequestReturnResult<T>
    {
        public WebRequestReturnResult(HttpWebRequest request, ReturnResult<T> action)
        {
            if (request == null)
                throw new ArgumentNullException("request", "request is null.");
            if (action == null)
                throw new ArgumentNullException("action", "action is null.");

            m_Request = request;
            m_ReturnResult = action;
        }

        private HttpWebRequest m_Request;
        public HttpWebRequest Request
        {
            get { return m_Request; }
        }


        private ReturnResult<T> m_ReturnResult;
        public ReturnResult<T> ReturnResult
        {
            get { return m_ReturnResult; }
        }
    }
}
