using System;
using Benday.Npr.Phone.Presentation.Interfaces;

namespace Benday.Npr.Phone.Presentation
{
    public abstract class MessageBoxViewModelBase : GalaSoft.MvvmLight.ViewModelBase, IViewModelBase
    {
        public event MessageBoxEventHandler MessageBoxRequested;

        public virtual void RequestMessageBox(string message)
        {
            if (MessageBoxRequested != null)
            {
                if (MessageBoxRequested != null) MessageBoxRequested(
                    this, new MessageBoxEventArgs(message));
            }
        }

        public virtual void RequestMessageBox(string message, bool isUnexpectedException, Exception ex)
        {
            if (MessageBoxRequested != null)
            {
                if (MessageBoxRequested != null) MessageBoxRequested(
                    this, new MessageBoxEventArgs(message, isUnexpectedException, ex));
            }
        }

        protected virtual void RequestMessageBox(string message, Exception ex)
        {
            if (MessageBoxRequested != null)
            {
                if (MessageBoxRequested != null) MessageBoxRequested(
                    this, new MessageBoxEventArgs(message, ex));
            }
        }
    }
}
