using System;
using System.Collections.Generic;
using Benday.Npr.Phone.Common;

namespace Benday.Npr.Phone.Presentation
{
    public abstract class ObjectFactoryViewModel : NetworkAvailabilityViewModel
    {
        public ObjectFactoryViewModel(IObjectFactory factory)
        {
            if (factory == null)
                throw new ArgumentNullException("factory", "factory is null.");

            m_ObjectFactoryInstance = factory;
        }

        private IObjectFactory m_ObjectFactoryInstance;
        protected IObjectFactory ObjectFactoryInstance
        {
            get { return m_ObjectFactoryInstance; }
        }
    }
}
