using System;
using System.Collections.Generic;
using Benday.Npr.Phone.Common.Models;

namespace Benday.Npr.Phone.Presentation
{
    public class Story : IStory
    {
        public Story()
        {
            Paragraphs = new List<IParagraph>();
        }

        public string Id { get; set; }
        public string UrlToHtml { get; set; }
        public string UrlToApi { get; set; }
        public string UrlShort { get; set; }
        public string Title { get; set; }
        public string Teaser { get; set; }
        public string TeaserMini { get; set; }
        public string Slug { get; set; }
        public DateTime StoryDate { get; set; }
        public DateTime PublishDate { get; set; }
        public string ShowName { get; set; }
        public DateTime ShowDate { get; set; }
        public string OrganizationName { get; set; }
        public string OrganizationAbbreviation { get; set; }
        public string OrganizationUrl { get; set; }
        public int Duration { get; set; }

        public bool HasUrlToMp3
        {
            get
            {
                if (String.IsNullOrEmpty(UrlToMp3) == false)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }

        public string UrlToMp3 { get; set; }
        public string UrlToWindowsMedia { get; set; }
        public IList<IParagraph> Paragraphs { get; set; }
        public string Author { get; set; }
    }
}
