using System;
using System.Collections.Generic;

namespace Benday.Npr.Phone.Presentation
{
    public class StorySelectableItem : SelectableItem
    {
        public StorySelectableItem(bool isSelected, 
            string id, 
            string text, 
            string value, 
            string description, 
            bool hasAudio, 
            DateTime publishDate)
            : base(isSelected, id, text, value, description)
        {
            m_HasAudio = hasAudio;
            m_PublishDate = publishDate;
        }

        private const string HasAudioPropertyName = "HasAudio";

        private bool m_HasAudio;
        public bool HasAudio
        {
            get
            {
                return m_HasAudio;
            }
            set
            {
                m_HasAudio = value;
                RaisePropertyChanged(HasAudioPropertyName);
            }
        }

        private const string PublishDatePropertyName = "PublishDate";

        private DateTime m_PublishDate;
        public DateTime PublishDate
        {
            get
            {
                return m_PublishDate;
            }
            set
            {
                m_PublishDate = value;
                RaisePropertyChanged(PublishDatePropertyName);
            }
        }
    }
}
