using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.Npr.Phone.DataAccess;
using Benday.Npr.Phone.Common.Repositories;

namespace Benday.Npr.Phone.UnitTests.DataAccess
{
    public class StoryRepositoryTester
    {
        /// <summary>
        /// Initializes a new instance of the StoryRepositoryTester class.
        /// </summary>
        /// <param name="repositoryInstance"></param>
        public StoryRepositoryTester(StoryRepository repositoryInstance)
        {
            m_RepositoryInstance = repositoryInstance;

            m_RepositoryInstance.StoryListRefreshed += new EventHandler<StoryListRefreshedEventArgs>(m_RepositoryInstance_StoryListRefreshed);
        }

        void m_RepositoryInstance_StoryListRefreshed(object sender, StoryListRefreshedEventArgs e)
        {
            m_WasStoryListRefreshedEventReceived = true;
            m_ProgramId = e.ProgramId;
        }

        private string m_ProgramId;
        public string ProgramId
        {
            get { return m_ProgramId; }
        }

        private bool m_WasStoryListRefreshedEventReceived;
        public bool WasStoryListRefreshedEventReceived
        {
            get { return m_WasStoryListRefreshedEventReceived; }
        }

        private StoryRepository m_RepositoryInstance;
        public StoryRepository RepositoryInstance
        {
            get { return m_RepositoryInstance; }
        }

        public void AssertEvent(string programId)
        {
            Assert.IsTrue(m_WasStoryListRefreshedEventReceived, "Didn't get StoryListRefreshed event.");
            Assert.AreEqual<string>(programId, m_ProgramId, "The received program id was wrong.");
        }
    }
}
