using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.Npr.Phone.Presentation;

namespace Benday.Npr.Phone.UnitTests.DataAccess
{
    [TestClass]
    public class ViewModelLocatorFixture : UnitTestBase
    {
        protected override void OnTestInitialize()
        {
            ViewModelLocator.DestroyInstance();
            ViewModelLocator.CreateInstance(ObjectFactoryInstance);
        }

        [TestMethod]
        public void InitializeViewModelLocator()
        {
            Assert.IsNotNull(ViewModelLocator.Instance, "Instance property is null.");
        }

        [TestMethod]
        public void ProgramsViewModelIsNotNull()
        {
            Assert.IsNotNull(ViewModelLocator.Instance.Programs, "Programs property is null.");
        }

        [TestMethod]
        public void StoryListViewModelIsNotNull()
        {
            Assert.IsNotNull(ViewModelLocator.Instance.StoryList, "StoryList property is null.");
        }

        [TestMethod]
        public void StoryViewModelIsNotNull()
        {
            Assert.IsNotNull(ViewModelLocator.Instance.Story, "Story property is null.");
        }
    }
}
