using System;
using Benday.Npr.Phone.Presentation.Interfaces;

namespace Benday.Npr.Phone.UnitTests.Presentation
{
    public class ProgramsViewModelEventTester
    {
        public ProgramsViewModelEventTester(IProgramsViewModel instance)
        {
            if (instance == null)
                throw new ArgumentNullException("instance", "instance is null.");

            m_Instance = instance;

            m_Instance.Programs.OnItemSelected += new EventHandler(Programs_OnItemSelected);
        }

        void Programs_OnItemSelected(object sender, EventArgs e)
        {
            GotSelectedEvent = true;
        }

        private IProgramsViewModel m_Instance;
        public IProgramsViewModel Instance
        {
            get { return m_Instance; }
        }

        public bool GotSelectedEvent { get; set; }
    }
}