using System;
using Benday.Npr.Phone.Presentation.Interfaces;

namespace Benday.Npr.Phone.UnitTests.Presentation
{
    public class StoryListViewModelEventTester
    {
        public StoryListViewModelEventTester(IStoryListViewModel instance)
        {
            if (instance == null)
                throw new ArgumentNullException("instance", "instance is null.");

            m_Instance = instance;

            m_Instance.Stories.OnItemSelected += new EventHandler(Stories_OnItemSelected);
        }

        void Stories_OnItemSelected(object sender, EventArgs e)
        {
            GotSelectedEvent = true;
        }

        private IStoryListViewModel m_Instance;
        public IStoryListViewModel Instance
        {
            get { return m_Instance; }
        }

        public bool GotSelectedEvent { get; set; }
    }
}
