using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Microsoft.Phone.Shell;

namespace Benday.Npr.Phone
{
    public class NavigateToHomeApplicationBarWatcher
    {
        public NavigateToHomeApplicationBarWatcher(ApplicationBarIconButton home)
        {
            if (home == null)
                throw new ArgumentNullException("home", "home is null.");

            m_Home = home;

            UpdateButtons();
        }

        private ApplicationBarIconButton m_Home;
        public ApplicationBarIconButton Home
        {
            get { return m_Home; }
        }

        private void UpdateButtons()
        {
            if (IsLightThemeEnabled() == true)
            {
                Home.IconUri = new Uri("/Images/Icons/Light/appbar.home.rest.png", UriKind.Relative);
            }
            else
            {
                Home.IconUri = new Uri("/Images/Icons/Dark/appbar.home.rest.png", UriKind.Relative);
            }
        }

        public bool IsLightThemeEnabled()
        {
            Visibility lightTheme = (Visibility)Application.Current.Resources["PhoneLightThemeVisibility"];

            if (lightTheme == System.Windows.Visibility.Visible)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
