using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Microsoft.Phone.Shell;

namespace Benday.Npr.Phone
{
    public class RefreshStoriesApplicationBarWatcher
    {
        public RefreshStoriesApplicationBarWatcher(
            ApplicationBarIconButton refresh)
        {
            if (refresh == null)
                throw new ArgumentNullException("refresh", "refresh is null.");
            
            m_Refresh = refresh;
            
            UpdateButtons();
        }

        private ApplicationBarIconButton m_Refresh;
        public ApplicationBarIconButton Refresh
        {
            get { return m_Refresh; }
        }

        private void UpdateButtons()
        {
            if (IsLightThemeEnabled() == true)
            {
                Refresh.IconUri = new Uri("/Images/Icons/Light/appbar.refresh.rest.png", UriKind.Relative);
            }
            else
            {
                Refresh.IconUri = new Uri("/Images/Icons/Dark/appbar.refresh.rest.png", UriKind.Relative);
            }            
        }

        public bool IsLightThemeEnabled()
        {
            Visibility lightTheme = (Visibility)Application.Current.Resources["PhoneLightThemeVisibility"];

            if (lightTheme == System.Windows.Visibility.Visible)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
