using System;
using System.Globalization;
using System.Windows.Data;

namespace Benday.Npr.Phone
{
    public class TimeFormatValueConverter : IValueConverter
    {
        public object Convert(
            object value,
            Type targetType,
            object parameter,
            CultureInfo culture)
        {
            if (value is DateTime)
            {
                DateTime valueAsDateTime = (DateTime)value;

                return valueAsDateTime.ToShortTimeString();
            }
            else
            {
                return String.Empty;
            }
        }

        public object ConvertBack(
            object value,
            Type targetType,
            object parameter,
            CultureInfo culture)
        {
            // this isn't really implemented

            return DateTime.Now;
        }
    }
}
